.. py:module:: pynx.utils

:mod:`pynx.utils`: useful functions for fft, prime factor, pattern simulation, plotting
=======================================================================================

.. toctree::
   :maxdepth: 2

Array
^^^^^
.. automodule:: pynx.utils.array
   :members:

Benchmark
^^^^^^^^^
.. automodule:: pynx.utils.benchmark
   :members:

Fourier shell correlation
^^^^^^^^^^^^^^^^^^^^^^^^^
.. automodule:: pynx.utils.fourier_shell_correlation
   :members:

History
^^^^^^^
.. automodule:: pynx.utils.history
   :members:

Math
^^^^
.. automodule:: pynx.utils.math
   :members:

Pattern simulation
^^^^^^^^^^^^^^^^^^
.. automodule:: pynx.utils.pattern
   :members:

Phase
^^^^^
.. automodule:: pynx.utils.phase
   :members:

Phase retrieval transfer function
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
.. automodule:: pynx.utils.phase_retrieval_transfer_function
   :members:

Plot utils
^^^^^^^^^^
.. automodule:: pynx.utils.plot_utils
   :members:
